#!/usr/bin/perl

###################################################
#                                                 #  
#     KewlChess  1997 Tom Wagner                 #
#                                                 #
#     This is Beta Version 1.21 and is freeware.  #
#     PLEASE DO NOT REDISTRIBUTE THIS SCRIPT!     #
#     Please do not remove these copyrights.      #
#     See README.TXT for more information.        #
#                                                 #   
#     This script may be obtained from            #
#     Tom Wagner's Web Site at:                   #
#     http://user.mc.net/~twagner/kewlchess.htm   #
#                                                 #
#     Parts of this program were based            #
#     on code used by permission from:            #
#                                                 #
#     EveryChat  1997 Matt Hahnfeld              #
#     http://www.cs.hope.edu/~hahnfld/everychat/  #
#                                                 #
###################################################

#################################################################
#                                                               #
#               Configuration Section                           #
#                                                               #
#    Edit the line below to show the absolute path to your      #
#    chess directory files. The path MUST include a trailing    #
#    slash. See documentation for more info. Also, edit the     #
#    line below to show the URL to your chess directory.        #                 #
                                               
     $filepath='/home/twagner/public_html/kewlchess/';    
     $URL='http://user.mc.net/~twagner/kewlchess/';

#################################################################

$board='board.txt'; 
$newboard='newboard.txt'; 
$messages='messages.htm'; 
$boardhtm='board.htm';    
$boardhtm1='board1.htm';
$help='kewlchess-help.htm';
$whtsq='#C3C3C3';       # color of white squares
$blksq='#F0CC8A';       # color of black squares
$background='#CBE7EF';  # color of background - lightblue

print "Content-type: text/html\nPragma: no-cache\n\n";

&get_form_data;

$chatcolor = $formdata{'chatcolor'};
$fontcolor = $formdata{'fontcolor'};

###### get the time #######

$now_string = localtime;
@thetime = split(/ +/,$now_string);
@theclock = split(/:/,$thetime[3]);
$ampm = 'am';
if ($theclock[0] > 11)
{
	$ampm = 'pm';
}
if ($theclock[0] == 0)
{
	$theclock[0] = 12;
}
if ($theclock[0] > 12)
{
	$theclock[0] -= 12;
}
else
{
	$theclock[0] += 0;
}
############################

if (exists $formdata{'newmove'})
{
@moves = ();
open(InFile, "$filepath$board")  || die;
while ($oneline = <InFile>)
 {
    $character = chop($oneline);
    push(@moves,$oneline);
 }
close(InFile);

$x = $formdata{'newmove'};
$from = substr($x,0,2),"\n";
$to = substr($x,2,2),"\n";
$decode='a8b8c8d8e8f8g8h8a7b7c7d7e7f7g7h7a6b6c6d6e6f6g6h6a5b5c5d5e5f5g5h5a4b4c4d4e4f4g4h4a3b3c3d3e3f3g3h3a2b2c2d2e2f2g2h2a1b1c1d1e1f1g1h1';
$from1 = index($decode,$from);
$from1 = ($from1)/2;
$to1 = index($decode,$to);
$to1 = ($to1)/2;
@moves[$to1] = @moves[$from1];
@moves[$from1] = '';
$fontcolor = substr(@moves[$to1],0,17);
$chatcolor = substr(@moves[$to1],0,17);

open (NEW, ">$filepath$board");
for ($digit = 0; $digit <= 64; $digit++)
  {
    print NEW @moves[$digit],"\n";
  }
print NEW $fontcolor,$x,"\n";   #  Save the last chess move.
close(NEW);
}


if (exists $formdata{'setup'})
{
@moves = ();
open(InFile, "$filepath$board")  || die;
while ($oneline = <InFile>)
 {
    $character = chop($oneline);
    push(@moves,$oneline);
 }
close(InFile);

$what = $formdata{'what'};
$to = $formdata{'where'};
$decode='a8b8c8d8e8f8g8h8a7b7c7d7e7f7g7h7a6b6c6d6e6f6g6h6a5b5c5d5e5f5g5h5a4b4c4d4e4f4g4h4a3b3c3d3e3f3g3h3a2b2c2d2e2f2g2h2a1b1c1d1e1f1g1h1';
$to1 = index($decode,$to);
$to1 = ($to1)/2;
@moves[$to1] = $what;

open (NEW, ">$filepath$board");
for ($digit = 0; $digit <= 64; $digit++)
  {
    print NEW @moves[$digit],"\n";
  }
print NEW $fontcolor,$to,"\n";   #  Save the last chess move.
close(NEW);
}


if (exists $formdata{'newgame'})
{
@moves = ();
open(InFile, "$filepath$newboard")  || die;
while ($oneline = <InFile>)
 {
   $character = chop($oneline);
   push(@moves,$oneline);
 }
close(InFile);

open (NEW, ">$filepath$board");
for ($digit = 0; $digit <= 64; $digit++)
  {
    print NEW @moves[$digit],"\n";
  }
print NEW $fontcolor,'<B>New Game</B>',"\n";   #  Save the last chess move.
close(NEW);

}


if (exists $formdata{'chat'})
{
open (HTMLOLD, "$filepath$messages") || die;
@lines=<HTMLOLD>;
close(HTMLOLD);

open (NEW, ">$filepath$messages");
print NEW '<HTML><HEAD><META HTTP-EQUIV="Refresh" CONTENT="10"></HEAD><BODY BGCOLOR=linen>';
print NEW "\n";
print NEW $formdata{'chatcolor'},$formdata{'chat'},'</font color>',"\n";
print NEW '<font size=-2>';
print NEW " \($thetime[0] $theclock[0]\:$theclock[1]$ampm\)",'<br>';
print NEW '<font size=3>';
	for ($i = 1; $i < 15; $i++)
	{
	    print NEW "$lines[$i]";
	}
print NEW '</BODY></HTML>';
print NEW "\n";
close(NEW);
}


@moves = ();
open(InFile, "$filepath$board")  || die;
while ($oneline = <InFile>)
 {
    $character = chop($oneline);
    push(@moves,$oneline);
 }
close(InFile);


##############################################

open (HTMLOLD, "$filepath$messages") or exit(0);
@lines=<HTMLOLD>;
close(HTMLOLD);	

open (NEW, ">$filepath$boardhtm");
print NEW '<HTML><HEAD><META HTTP-EQUIV="Refresh" CONTENT="15"></HEAD><BODY BGCOLOR=',$background,'>';

print NEW '<table border=0>';
print NEW '<tr>';
print NEW '<td bgcolor=',$background,' height=25 width=25><center>8</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[0],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[1],'</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[2],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[3],'</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[4],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[5],'</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[6],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[7],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>7</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[8],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[9],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[10],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[11],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[12],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[13],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[14],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[15],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>6</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[16],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[17],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[18],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[19],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[20],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[21],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[22],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[23],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>5</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[24],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[25],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[26],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[27],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[28],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[29],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[30],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[31],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>4</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[32],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[33],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[34],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[35],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[36],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[37],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[38],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[39],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>3</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[40],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[41],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[42],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[43],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[44],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[45],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[46],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[47],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>2</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[48],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[49],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[50],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[51],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[52],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[53],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[54],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[55],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>1</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[56],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[57].'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[58],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[59],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[60],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[61],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[62],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[63],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center></td>';
print NEW '<td bgcolor=',$background,'><center>a</td>';
print NEW '<td bgcolor=',$background,'><center>b</td>';
print NEW '<td bgcolor=',$background,'><center>c</td>';
print NEW '<td bgcolor=',$background,'><center>d</td>';
print NEW '<td bgcolor=',$background,'><center>e</td>';
print NEW '<td bgcolor=',$background,'><center>f</td>';
print NEW '<td bgcolor=',$background,'><center>g</td>';
print NEW '<td bgcolor=',$background,'><center>h</td>';
print NEW '</tr>';
print NEW '</table>';

print NEW '<FORM ACTION="board1.htm" METHOD="GET"><center>';
print NEW "\<input type=submit value=\"Flip Board\"\>";
# $fontcolor = substr(@moves[$to1],2,17);
print NEW '<nobr>  Last move: <B>',$fontcolor,@moves[65],'</font color></B><p>';
print NEW '</form>';
print NEW '</CENTER>';
close(NEW);

open (NEW, ">$filepath$boardhtm1");
print NEW '<HTML><HEAD><META HTTP-EQUIV="Refresh" CONTENT="15"></HEAD><BODY bgcolor=',$background,'>';

print NEW '<table border=0>';
print NEW '<tr>';
print NEW '<td bgcolor=',$background,' height=25 width=35><center>1</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[63],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[62],'</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[61],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[60],'</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[59],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[58],'</td>';
print NEW '<td bgcolor=',$whtsq,' width=25>',@moves[57],'</td>';
print NEW '<td bgcolor=',$blksq,' width=25>',@moves[56],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>2</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[55],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[54],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[53],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[52],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[51],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[50],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[49],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[48],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>3</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[47],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[46],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[45],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[44],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[43],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[42],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[41],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[40],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>4</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[39],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[38],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[37],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[36],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[35],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[34],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[33],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[32],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>5</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[31],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[30],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[29],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[28],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[27],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[26],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[25],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[24],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>6</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[23],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[22],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[21],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[20],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[19],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[18],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[17],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[16],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>7</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[15],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[14],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[13],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[12],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[11],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[10],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[9],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[8],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center>8</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[7],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[6].'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[5],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[4],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[3],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[2],'</td>';
print NEW '<td bgcolor=',$blksq,'>',@moves[1],'</td>';
print NEW '<td bgcolor=',$whtsq,'>',@moves[0],'</td>';
print NEW '</tr><tr>';
print NEW '<td bgcolor=',$background,' height=25><center></td>';
print NEW '<td bgcolor=',$background,'><center>h</td>';
print NEW '<td bgcolor=',$background,'><center>g</td>';
print NEW '<td bgcolor=',$background,'><center>f</td>';
print NEW '<td bgcolor=',$background,'><center>e</td>';
print NEW '<td bgcolor=',$background,'><center>d</td>';
print NEW '<td bgcolor=',$background,'><center>c</td>';
print NEW '<td bgcolor=',$background,'><center>b</td>';
print NEW '<td bgcolor=',$background,'><center>a</td>';
print NEW '</tr>';
print NEW '</table>';

print NEW '<FORM ACTION="board.htm" METHOD="GET"><center>';
print NEW "\<input type=submit value=\"Flip Board\"\>";
print NEW '<nobr>  Last move: <B>',$fontcolor,@moves[65],'</font color></B><p>';
print NEW '</form>';

print NEW '</CENTER>';

close(NEW);

print '<html><head><title>Tom Wagner\'s KewlChess Beta Page</title></head>',"\n",'<BODY BGCOLOR=#CBE7EF>';
print '<center><img src=http://user.mc.net/~twagner/kewlchess-small.gif><br>';

print "\<FORM ACTION=\"$ENV{'SCRIPT_NAME'}\" METHOD=\"POST\"\>Enter move \(example\: e2e4\)\:\n";
print "\<input type=text name=newmove size=6\>\n";
print "\<input type=submit value=\"Send Move\"\>";
print "\</form\>";

print "\<FORM ACTION=\"$ENV{'SCRIPT_NAME'}\" METHOD=\"POST\"\>Enter chat message\:\n";
print "\<input name=chatcolor type=hidden value=\"$chatcolor\"\>\n";
print "\<input name=fontcolor type=hidden value=\"$fontcolor\"\>\n";
print "\<input type=text name=chat size=38>\n";
print "\<br><input type=submit value=\"Send Message\"\>";
print '</form><hr>';

print "\<FORM ACTION=\"$ENV{'SCRIPT_NAME'}\" METHOD=\"POST\"\>\n";
print "\<input type=hidden name=newgame>\n";
print "\<input type=submit value=\"Begin a new game\"\>";
print '</form><hr>';

print "\<FORM ACTION=\"$ENV{'SCRIPT_NAME'}\" METHOD=\"POST\"\>Modify the board\:\n";
print '<select name=what>';
print '<option selected value="<br>">Select a piece.';
print '<option value="<font color=red ><img src=wp.gif></font>">White Pawn';
print '<option value="<font color=red ><img src=wr.gif></font>">White Rook';
print '<option value="<font color=red ><img src=wn.gif></font>">White Knight';
print '<option value="<font color=red ><img src=wb.gif></font>">White Bishop';
print '<option value="<font color=red ><img src=wq.gif></font>">White Queen';
print '<option value="<font color=red ><img src=wk.gif></font>">White King';
print '<option value="<font color=blue><img src=bp.gif></font>">Black Pawn';
print '<option value="<font color=blue><img src=br.gif></font>">Black Rook';
print '<option value="<font color=blue><img src=bn.gif></font>">Black Knight';
print '<option value="<font color=blue><img src=bb.gif></font>">Black Bishop';
print '<option value="<font color=blue><img src=bq.gif></font>">Black Queen';
print '<option value="<font color=blue><img src=bk.gif></font>">Black King';
print '<option value="<br>">Empty space';
print '</select>';
print '<BR>Where does it go?';
print '<input type=text name=where size=4>';
print "\<input name=setup type=hidden value=setup>\n";
print '<input type=submit value=Submit>';
print '</form>';

print '<hr><font size=3>';
print '<B><a href=',$URL,$help,'>How Do I Play?</a></b>';

print '<hr><font size=2>';
print '<p><B>KewlChess  1997 <A HREF=mailto:twagner@mc.net>Tom Wagner</a>';
print '<br>(Beta Version 1.21)</b>';

print '<font size=1><p>Portions of this program were based on code used by permission from:';
print '<br><a href=http://www.cs.hope.edu/~hahnfld/everychat/ TARGET=_parent>EveryChat</a>  1997 Matt Hahnfeld';

print '<p>[<a href=http://user.mc.net/~twagner/kewlchess.htm TARGET=_parent>KewlChess</a>]';
print '[<a href=http://user.mc.net/~twagner/kewlcheckers.htm TARGET=_parent>KewlCheckers</a>]';
print '[<a href=http://user.mc.net/~twagner/wwwboard/ TARGET=_parent>Support Forum</a>]';
print '<br>Don\'t forget to visit Tom Wagner\'s ';
print '<A HREF=http://user.mc.net/~twagner/ TARGET=_parent>Music Library</a>.';
print '<br></center><br><hr>';
print '</body></html>';


########################################
# subs

sub get_form_data {
	$buffer = "";
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs=split(/&/,$buffer);
	foreach $pair (@pairs)
	{
		@a = split(/=/,$pair);
		$name=$a[0];
		$value=$a[1];
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$value =~ s/\+/ /g;
		# $value =~ s/\</\&lt\;/g;  # html tag removal (remove these lines to enable HTML tags in messages)
		# $value =~ s/\>/\&gt\;/g;  # html tag removal (remove these lines to enable HTML tags in messages)
		$value =~ s/\r//g;
		push (@data,$name);
		push (@data, $value);
	}
	%formdata=@data;
	%formdata;
}
